class QueuedMessage {
  final String recipientId;
  final String message;
  final DateTime timestamp;
  final int retryCount;

  QueuedMessage({
    required this.recipientId,
    required this.message,
    DateTime? timestamp,
    this.retryCount = 0,
  }) : timestamp = timestamp ?? DateTime.now();

  QueuedMessage copyWith({int? retryCount}) {
    return QueuedMessage(
      recipientId: recipientId,
      message: message,
      timestamp: timestamp,
      retryCount: retryCount ?? this.retryCount,
    );
  }
}