import 'dart:async';

import 'package:torchat/src/p2p/message_queue/outgoing_queue.dart';

class SyncManager {
  final OutgoingQueue queue;
  final Duration interval;
  Timer? _timer;

  SyncManager(this.queue, {this.interval = const Duration(seconds: 10)});

  void start() {
    _timer ??= Timer.periodic(interval, (_) => _flush());
  }

  void stop() => _timer?.cancel();

  Future<void> _flush() async {
    if (!queue.hasMessages) return;
    final msgs = queue.drain();
    // TODO: iterate peers from discovery service and send via gRPC client
    for (final msg in msgs) {
      print('[SyncManager] Would send message ${msg.id}');
    }
  }
}